%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                      PSG Type    PSG Object             Location in Problem Statement              Class
%matrix_sde_data             data        matrix_sde             avg_g(matrix_sde)                          double
%                                                               pm_pen(vector_benchmark_sd, matrix_sde)
%matrix_sde_vars             vars        matrix_sde             avg_g(matrix_sde)                          cell
%                                                               pm_pen(vector_benchmark_sd, matrix_sde)
%matrix_budget_data          data        matrix_budget          linear(matrix_budget)                      double
%matrix_budget_vars          vars        matrix_budget          linear(matrix_budget)                      cell
%vector_ubound_sd_data       data        vector_ubound_sd       MultiConstraint: <= vector_ubound_sd       double
%vector_benchmark_sd_data    data        vector_benchmark_sd    pm_pen(vector_benchmark_sd, matrix_sde)    double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine_3000(matrix_sde_data,matrix_sde_vars,matrix_budget_data,matrix_budget_vars,vector_ubound_sd_data,vector_benchmark_sd_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_sde',matrix_sde_data,matrix_sde_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_budget',matrix_budget_data,matrix_budget_vars,[],[]);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_ubound_sd',vector_ubound_sd_data);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_benchmark_sd',vector_benchmark_sd_data);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'maximize',...
'  avg_g(matrix_sde)',...
'Constraint: = 1',...
'  linear(matrix_budget)',...
'MultiConstraint: <= vector_ubound_sd',...
'  pm_pen(vector_benchmark_sd, matrix_sde)',...
'Box: >= 0, <= 1',...
' ');
%Change parameters with their values in problem statement:

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

