%This Example for using users m-function Optimization_subroutine_3000.m was created automatically by PSG Toolbox.

%Function description:

%maximize
%avg_g(matrix_sde)
%Constraint: = 1
%linear(matrix_budget)
%MultiConstraint: <= vector_ubound_sd
%pm_pen(vector_benchmark_sd, matrix_sde)
%Box: >= 0, <= 1
%
%Input variables:
%
%Inputs                      PSG Type    PSG Object             Location in Problem Statement              Class
%matrix_sde_data             data        matrix_sde             avg_g(matrix_sde)                          double
%                                                               pm_pen(vector_benchmark_sd, matrix_sde)
%matrix_sde_vars             vars        matrix_sde             avg_g(matrix_sde)                          cell
%                                                               pm_pen(vector_benchmark_sd, matrix_sde)
%matrix_budget_data          data        matrix_budget          linear(matrix_budget)                      double
%matrix_budget_vars          vars        matrix_budget          linear(matrix_budget)                      cell
%vector_ubound_sd_data       data        vector_ubound_sd       MultiConstraint: <= vector_ubound_sd       double
%vector_benchmark_sd_data    data        vector_benchmark_sd    pm_pen(vector_benchmark_sd, matrix_sde)    double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


%Load data from mat-file:
load('D:\American Optimal Decisions\PSG\MATLAB_Stan\All\Portfolio Optimization with Second-Order Stochastic\problem1_dataset1_ssd_DAX_1\Optimization_subroutine_3000_data.mat')

%Save variables from mat-file to Workspace:
tbpsg_export_to_workspace(toolboxstruc_arr)

%Run users m-function Optimization_subroutine_3000:

[solution_str,outargstruc_arr] = Optimization_subroutine_3000(matrix_sde_data,matrix_sde_vars,matrix_budget_data,matrix_budget_vars,vector_ubound_sd_data,vector_benchmark_sd_data);

%Extract Objective:
val_obj = tbpsg_objective(solution_str, outargstruc_arr);

disp(' ');
disp('Objective = ');
disp(val_obj);

%Extract optimal solution:
point_data = tbpsg_optimal_point_data(solution_str, outargstruc_arr);

disp(' ');
disp('Optimal point = ');
disp(point_data);

%Extract structure containing PSG solution reports:
output_structure = tbpsg_solution_struct(solution_str, outargstruc_arr);

disp(' ');
disp('Structure with PSG solution = ');
disp(output_structure);

%Uncomment the following lines to extract solutions details:

%output = tbpsg_isoptimal(solution_str, outargstruc_arr);

%output = tbpsg_function_data(solution_str, outargstruc_arr);

%output = tbpsg_function_names(solution_str, outargstruc_arr);

%output = tbpsg_time(solution_str, outargstruc_arr);

%output = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);

%output = tbpsg_constraints_vars(solution_str, outargstruc_arr);

%output = tbpsg_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_constraint_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_vars(solution_str, outargstruc_arr);

%output = tbpsg_vector_data(solution_str, outargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 
